#!/bin/sh -e

PORT=8080

while getopts "p:" OPT; do
  case $OPT in
    p) PORT=$OPTARG ;;
  esac
done

if [ "$PORT" != "80" ];
then PORTSUFFIX="-on-$PORT";
else PORTSUFFIX="";
fi

PIDFILE=/usr/local/var/run/nhttpd$PORTSUFFIX.pid

kill $(cat $PIDFILE)
rm $PIDFILE
