// HTTP Auth module for nhttpd.

//var rfc_util=require('../../src/rfc_util.js')
var rfc_util=require('./rfc_util.js') // the require() wrapper used for async loading doesn't resolve relative to the file containing the require call but to httpd.js (which is a bug)

/*
exports.http_auth=http_auth

/*
function http_auth(passwd_file){
 // passwd_file is a file with "username:password" lines, in the same format used by Apache httpd.

 // the returned function takes a request and tests it against the file, returing one of the following strings:
 // "user:{username}", where {username} is a username appearing in the file which was authenticated successfully
 // "failed" if authentication failed
 // "unauthenticated" for requests that did not include authentication information
 return function(req,resp){
  if(!('Auth' in req.headers))return "unauthenticated"
  */

exports.simple_authenticator=simple_authenticator

// Takes an array of user,password pairs; for testing or very simple setups.
function simple_authenticator(logins){var cache
 assert(typeof logins=='string','logins argument is string ('+typeof logins+')')
 // logins is a list of username:password lines
 logins=logins.split(/\r\n|\r|\n/)
 // Because the entire list is provided when we are called, and Basic authentication is so simple, we can calculate all the base64 tokens in advance
 // Authentication is then just a property access on the cache object.
 cache={}
 logins.forEach(function(login){var user
   user=login.split(':')[0]
   cache[rfc_util.base64_encode(login)]=user})
 return function (req,cb){cb(authenticator(req))}
 function authenticator(req){var base64,match
  dump(JSON.stringify(req.headers))
  if(!('authorization' in req.headers))return "unauthenticated"
  match=/^basic +(.*)/i.exec(req.headers.authorization)
  if(!match)return "failed"
  base64=match[1]
  if(cache[base64])return "user:"+cache[base64]
  return "failed"}}

exports.challenge401=challenge401

function challenge401(realm){var body
 body='<!doctype html><title>Authorization Required</title><h1>401 Authorization required</h1>' // XXX use the same error template as handlers.js (or move this function there)
 return function(cont){cont([1,challenge401_handler])}
 function challenge401_handler(req,resp){
  resp.writeHead(401,{'WWW-Authenticate':'Basic realm="'+realm+'"'
                    ,'Content-Length':body.length})
  resp.write(body)
  resp.end()}}