// type Continuable a = Continuation a → _
// type Continuation a = a → _

// Continuations are called only for their side-effects, hence the return type _, meaning unused.

// parallel :: [Continuable a] → Continuable [a]
exports.parallel=parallel
function parallel(continuables){return function(cont){var l,i,outstanding,results
  results=[]
  l=outstanding=continuables.length
  if(!l)cont([])
  for(i=0;i<l;i++) continuables[i](go(i))
  // go :: Integer → Continuation a
  function go(i){return function(a){
    results[i]=a
    outstanding--
    if(outstanding===0) cont(results)}}}}

// sequence :: [Continuable a] → Continuable [a]
exports.sequence=sequence
function sequence(continuables){return function(cont){var results=[]
  go()
  function go(){
    if(!continuables.length) cont(results)
    else continuables.shift()(function(x){results.push(x);go()})}}}